package com.jz.common.utils.web;

import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import com.jz.dmp.modules.model.DmpMember;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;


/** 
* @ClassName: SessionUtils 
* @Description: TODO(session相关工具类) 
* @author ybz 
* @date 2017年4月21日 下午5:11:16 
*  
*/
public class SessionUtils {
	
	/** 
	* @Title: getRequest 
	* @Description: TODO(获取request) 
	* @param @return    设定文件 
	* @return HttpServletRequest    返回类型 
	* @throws 
	*/
	public static HttpServletRequest getRequest() {
		ServletRequestAttributes requestAttributes = (ServletRequestAttributes) RequestContextHolder
				.getRequestAttributes();
		return requestAttributes == null ? null : requestAttributes.getRequest();
	}
	
	/** 
	* @Title: getSession 
	* @Description: TODO(获取session) 
	* @param @return    设定文件 
	* @return HttpSession    返回类型 
	* @throws 
	*/
	public static HttpSession getSession(){
        return getRequest().getSession(false);  
    } 
	
	/** 
	* @Title: getSessionAttribute 
	* @Description: TODO(获取session属性) 
	* @param @param name
	* @param @return    设定文件 
	* @return Object    返回类型 
	* @throws 
	*/
	public static Object getSessionAttribute(String name){  
        HttpServletRequest request = getRequest();
        return request == null?null:request.getSession().getAttribute(name);  
    }  
      
    /** 
    * @Title: setSessionAttribute 
    * @Description: TODO(设置session属性值) 
    * @param @param name
    * @param @param value    设定文件 
    * @return void    返回类型 
    * @throws 
    */
    public static void setSessionAttribute(String name,Object value){
        HttpServletRequest request = getRequest();
        if(request!=null){  
            request.getSession().setAttribute(name, value);   
        }  
    } 
    
    /** 
    * @Title: getSessionUserId 
    * @Description: TODO(获取登录用户ID) 
    * @param @return
    * @param @throws Exception    设定文件 
    * @return long    返回类型 
    * @throws 
    */
/*	public static Integer getSessionUserId() throws Exception {
		DmpSystemUser user = (DmpSystemUser) SessionUtils.getSessionAttribute("LOGIN_USER");
		if (user != null && user.getId() != null && user.getId() != 0l) {
			return user.getId();
		} else {
			return null;
		}
	}*/
    

    
    /** 
    * @Title: getSecurityUser 
    * @Description: TODO(获取登录用户) 
    * @param @return    设定文件 
    * @return DspSystemUser    返回类型 
    * @throws 
    */
    public static DmpMember getSecurityUser(){
    	Object principal = SecurityContextHolder.getContext().getAuthentication().getPrincipal();
    	if (principal==null || "anonymousUser".equals(principal)) {
			return null;
		}
    	return (DmpMember)principal;
    }
    
    /**  
    * @Title: getAuthentication  
    * @Description: TODO(获取authentication)  
    * @param @return    参数  
    * @return Authentication    返回类型  
    * @throws  
    */ 
    public static Authentication getAuthentication() {
    	return SecurityContextHolder.getContext().getAuthentication();
    }
    
    /**  
    * @Title: setAuthentication  
    * @Description: TODO(设置authentication)  
    * @param @param authentication    参数  
    * @return void    返回类型  
    * @throws  
    */ 
    public static void setAuthentication(Authentication authentication) {
    	SecurityContextHolder.getContext().setAuthentication(authentication);
    }
    
}
