package com.jz.dmp.modules.dao;

import com.jz.dmp.modules.controller.DataIntegration.bean.DvRuleTDto;
import com.jz.dmp.modules.model.DvRuleT;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * ???(DvRuleT)表数据库访问层
 *
 * @author Bellamy
 * @since 2020-12-24 10:56:17
 */
public interface DvRuleTDao {

    /**
     * 通过ID查询单条数据
     *
     * @param ruleId 主键
     * @return 实例对象
     */
    DvRuleT queryById(Long ruleId);

    /**
     * 查询指定行数据
     *
     * @param offset 查询起始位置
     * @param limit  查询条数
     * @return 对象列表
     */
    List<DvRuleT> queryAllByLimit(@Param("offset") int offset, @Param("limit") int limit);


    /**
     * 通过实体作为筛选条件查询
     *
     * @param dvRuleT 实例对象
     * @return 对象列表
     */
    List<DvRuleT> queryAll(DvRuleT dvRuleT);

    /**
     * 新增数据
     *
     * @param dvRuleT 实例对象
     * @return 影响行数
     */
    int insert(DvRuleT dvRuleT);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<DvRuleT> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<DvRuleT> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<DvRuleT> 实例对象列表
     * @return 影响行数
     */
    int insertOrUpdateBatch(@Param("entities") List<DvRuleT> entities);

    /**
     * 修改数据
     *
     * @param dvRuleT 实例对象
     * @return 影响行数
     */
    int update(DvRuleT dvRuleT);

    /**
     * 通过主键删除数据
     *
     * @param ruleId 主键
     * @return 影响行数
     */
    int deleteById(Long ruleId);

    List<DvRuleTDto> queryJyRuleListPage(DvRuleT dvRuleT) throws Exception;
}